var Est91000_ProgramacaoDoInventarioCego_Services = function(General, Lib00206_InfComplProduto_Controller, ZHPromise, EstUtil, Est91000_ProgramacaoDoInventarioCego_Repository) {

    this.getFilialLogada = function() {
        const filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }
	    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };

    this.getComplementaryProductInformation = function(widget) {
        const promise = ZHPromise.defer();
        if (widget.currentRow.CDARVPROD) {
            widget.promise = promise;
            Lib00206_InfComplProduto_Controller.infComplementares(widget, widget.currentRow);
        }
        else {
            promise.reject();
        }
        return promise;
    };

    this.setGenerationDateandOperator = function(widget) {
        widget.dataSource.data.forEach(inventory => {
            inventory.DTGERACAOINVEST = inventory.DTGERACAOINVEST.substr(0, 10) + " - " + inventory.CDOPERADOR;
        });
    };

    this.saveProducts = function(row) {
        return Est91000_ProgramacaoDoInventarioCego_Repository.saveProducts(row);
    };

    this.checkInventoryHandler = function(cdFilial, dtContagem, firstTest = true) {
        const row = {
            "CDFILIAL": cdFilial,
            "DTCONTAGEM": dtContagem,
            "FIRSTTEST": firstTest
        };

        return Est91000_ProgramacaoDoInventarioCego_Repository.checkInventoryHandler(row);
    };

    this.onGenerateInventory = function(row, filiais) {
        row.CDFILIAL = filiais;
        return Est91000_ProgramacaoDoInventarioCego_Repository.onGenerateInventory(row);
    };

    this.onDeleteInventory = function(dataSet) {
        return Est91000_ProgramacaoDoInventarioCego_Repository.onDeleteInventory(dataSet);
    };

};
Configuration(function(ContextRegister) {
    ContextRegister.register('Est91000_ProgramacaoDoInventarioCego_Services', Est91000_ProgramacaoDoInventarioCego_Services);
});
